import * as Vue from "vue";
import { PropOptions, ComponentOptions } from "vue";
/**
 * decorator of a prop
 * @param  {PropOption}        options the option for the prop
 * @return {PropertyDecorator}         PropertyDecorator
 */
export declare function prop(options: (PropOptions | {
    new (...args: any[]): any;
})): PropertyDecorator;
/**
 * decorator of a watch function
 * @param  {string}            path the path or the expression to observe
 * @return {MethodDecorator}      MethodDecorator
 */
export declare function watch(path: string): MethodDecorator;
export declare function Component<V extends Vue>(options: ComponentOptions<V>): ClassDecorator;
