/* vue-property-decorator verson 3.0.0 MIT LICENSE copyright 2016 kaorun343 */
"use strict";
var vue_class_component_1 = require("vue-class-component");
/**
 * decorator of a prop
 * @param  {PropOption}        options the option for the prop
 * @return {PropertyDecorator}         PropertyDecorator
 */
function prop(options) {
    return function (target, propertyKey) {
        (target.constructor.props || (target.constructor.props = {}))[propertyKey] = options;
    };
}
exports.prop = prop;
/**
 * decorator of a watch function
 * @param  {string}            path the path or the expression to observe
 * @return {MethodDecorator}      MethodDecorator
 */
function watch(path) {
    return function (target, propertyKey) {
        (target.constructor.watch || (target.constructor.watch = {}))[path] = propertyKey;
    };
}
exports.watch = watch;
function Component(options) {
    return function (Class) {
        Object.assign(options, { props: Class.props, watch: Class.watch });
        return vue_class_component_1.default(options)(Class);
    };
}
exports.Component = Component;
